#include <stdio.h>
#include <ctype.h>
#include <math.h>
#include <map>
#include <string>

using std::map;
using std::string;

double m[200][200];

void resetMatrix( int c )
{
    for ( int i=0; i<c; i++ )
	for ( int j=0; j<c; j++ )
	    m[i][j] = 0.0;
}

void printMatrix( int c )
{
    for ( int i=0; i<c; i++ ) {
	for ( int j=0; j<c; j++ )
	    printf( "%3.8lf   ", m[i][j] );
	printf( "\n" );
    }
    printf( "\n" );
}

int main(int argc, char** argv)
{
    int c;
    scanf( "%d\n", &c );
    while ( c ) {
	resetMatrix( c );
	map<string, int> cnames;
	for ( int i=0; i<c; i++ ) {
	    char s[10];
	    scanf( "%s", s );
	    string str = string( s );
	    cnames[s] = i;
	}
	int r;
	bool arbitrage = false;
	scanf( "%d\n", &r );
	for ( int i=0; i<r; i++ ) {
	    char s1[10];
	    char s2[10];
	    int n1, n2;
	    scanf( "%s %s %d:%d\n", s1, s2, &n1, &n2 );
	    int i1 = cnames[s1];
	    int i2 = cnames[s2];
	    double p = (double)n2/(double)n1;
	    if ( m[i1][i2] < p )
		m[i1][i2] = p;
	}
	int i = c-1;
	//printMatrix( c );
	while ( !arbitrage && i ) {
	    for ( int j=0; (j<i) && !arbitrage; j++ ) {
		if ( m[i][j] > 0.0 ) {
		    for ( int k=0; (k<i) && !arbitrage; k++ ) {
			if (( m[k][i] > 0.0 ) && ( m[k][i]*m[i][j] > m[k][j]) ) {
			    m[k][j] = m[k][i]*m[i][j];
			    if ( ( k==j ) && ( m[k][j] > 1.0 ) )
				arbitrage = true;
			}
		    }
		}
	    }
	    i--;
	    //printMatrix( c );
	}
	if ( arbitrage )
	    printf( "Arbitrage\n" );
	else
	    printf( "Ok\n" );
	scanf( "%d\n", &c );
    }
    return 0;
}

